# std::__basic_future< _Res > Class Template Reference
[Futures]

Common implementation for future and shared_future. More...

Inheritance diagram for std::__basic_future< _Res >:
[legend]

List of all members.

## Public Member Functions

- __basic_future (const __basic_future &)
- __basic_future & operator= (const __basic_future &)
- bool valid () const
- void wait () const
- template<typename _Rep , typename _Period > bool wait_for (const chrono::duration< _Rep, _Period > &__rel) const
- template<typename _Clock , typename _Duration > bool wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types

- typedef __future_base::_Result
  < _Res > & __result_type
- typedef shared_ptr< _State > __state_type

## Protected Member Functions

- __basic_future (const __state_type &__state)
- __basic_future (const shared_future< _Res > &)
- __basic_future (shared_future< _Res > &&)
- __basic_future (future< _Res > &&)
- __result_type _M_get_result ()
- void _M_swap (__basic_future &__that)

## Detailed Description

### template<typename _Res>
class std::__basic_future< _Res >

Common implementation for future and shared_future.

Definition at line 480 of file future.

## Member Function Documentation

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | `[inline, protected]`

Wait for the state to be ready and rethrow any stored exception.

Definition at line 513 of file future.

Referenced by std::shared_future< _Res >::get(), std::future< void >::get(), and std::future< _Res >::get().

The documentation for this class was generated from the following file:

- future